routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });
Route::get('/', 'Auth\LoginController@showLoginForm');
Auth::routes();

Route::group(['middleware' => ['auth']], function() {
	Route::get('/home', 'HomeController@index')->name('home');

	Route::resource('/users', 'UserController');
	Route::resource('/measurements', 'MeasurementController');
    Route::resource('/variants', 'VariantController');
    Route::resource('/attributes', 'AttributeController');
	Route::resource('/brands', 'BrandController');
    Route::resource('/categories', 'CategoryController');
    Route::resource('/countries', 'CountryController');
    Route::resource('/products', 'ProductController');
    Route::resource('/options', 'OptionController');

    Route::delete('/deleteproducts', 'ProductController@deleteMultipleProducts')->name('products.multipledelete');
    Route::resource('/orders', 'OrderController');
    Route::get('/print/{id}', 'OrderController@printPreview')->name('orders.print');
    Route::post('/orders/updatestatus', 'OrderController@changeStatus')->name('orders.updatestatus');
    Route::get('/customers', 'UserController@customers')->name('users.customers');

    Route::post('/variantoptions', 'VariantController@getVariantOptions')->name('variant.options');
    Route::post('/fetchattributes', 'MeasurementController@getAttributes')->name('measurement.attributes');

    Route::post('customer/status', 'UserController@changeStatus')->name('user.updatestatus');

    Route::delete('/deletebanners', 'OptionController@deleteBanners')->name('option.bannerdelete');
});

//Route::get('admin/home', 'HomeController@adminHome')->name('admin.home')->middleware('is_admin');

Route::get('/clear-cache', function() {
    Artisan::call('cache:clear');
    Artisan::call('route:clear');
    Artisan::call('config:clear');
    Artisan::call('view:clear');
    // return "Cache is cleared";
    return view('cache');
})->name('cache.clear');

app/Http/Controllers/_new_ProductController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Product;
use App\Category;
use App\Brand;

use Redirect;
use DB;
use Image;
use Carbon\Carbon;
use Validator,Response,File;
use Illuminate\Support\Arr;
use Illuminate\Support\Str;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $products = DB::table('products as p')
                    ->leftJoin('categories as c', 'p.category_id', '=', 'c.id')
                    ->leftJoin('brands as b', 'p.brand_id', '=', 'b.id')
                    ->leftJoin('images as im', 'p.default_image_id', '=', 'im.id')
                    ->select('p.id', 'p.name', 'p.price', 'p.min_price', 'im.url as image', 'p.created_at',
                        'c.name as category', 'b.name as brand')
                    ->orderBy('id', 'DESC')
                    ->get();


        return view('product.index',compact( 'products'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // Categories
        $categories = DB::table('categories as child')
            ->leftJoin('categories as parent', 'child.category_id', '=', 'parent.id')
            ->select('child.*', 'parent.name as parent')   
            ->where('child.category_id','<>', 0)        
            ->orderBy('child.id', 'DESC')->get();

        $brand = Brand::all()->pluck('name', 'id')->toArray();  

        $countries = DB::table('countries')->orderBy('name', 'ASC')
                        ->pluck('name', 'id')->toArray();

        $measurement = DB::table('measurement')->orderBy('name', 'ASC')
                        ->pluck('name', 'id')->toArray();

        $variants = DB::table('variants')
                        ->orderBy('name', 'ASC')
                        ->pluck('name', 'id')->toArray();

        $products = DB::table('products as p')
                    ->select('p.*')         
                    ->orderBy('p.name', 'ASC')->get();     

        return view('product.create',compact( 'categories', 'brand', 'products', 'countries', 'measurement', 'variants'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $this->validate($request, [
            'name' => 'required',
            'price' => 'required', 
            'description' => 'required',  
            'category_id' => 'required',        
            'image' => 'required|file|image|mimes:jpeg,png,jpg,gif,svg|max:2048'                       
        ]); 
        
        $input = $request->all();

        ####### Add Product ######
        $img = null;
        if ($request->hasfile('image')) {

            $file = $request->file('image');
            $response = $this->postImage($_FILES);

            if(isset($response['status']) && $response['status'] == 'SUCCESS'){
                $img = $response['data']['id'];
            }else{
                // error
            }        
        } 
        $lastId = Product::orderBy('id', 'desc')->first()->id;
       
        $in_prod = [
                'id'          => (int) $lastId+1,
                'name'        => $input['name'],
                'description' => $input['description'],
                'price'       => $input['price'],
                'min_price'   => $input['min_price']?$input['min_price']: 0,
                'barcode'     => $input['barcode']?$input['barcode']: null,
                'measurement_id' => $input['measurement_id']?$input['measurement_id']: 0,
                'category_id' => $input['category_id'],
                'country_id'  => $input['country_id']?$input['country_id']: 0,
                'brand_id'    => $input['brand_id']? $input['brand_id']: 0,
                'default_image_id' => $img,
                'is_blocked'  => $input['is_blocked'],
                ];

        $product = Product::create($in_prod);

        ## Update IMAGE - PRODUCTID ##
        if($img > 0){
            DB::table('images')->where('id', $img)->update(['product_id' => $product->id]);
        }

        ####### Product Options ######
        if($product){  
            $lastId = DB::table('product_options')->orderBy('id', 'desc')->first()->id;

            $in_prod_opt = [
                'id'            => (int) $lastId+1,
                'sku'           => $input['sku']?$input['sku']: null,                
                'price'         => $input['price'],
                'count'         => $input['count'],
                'reserved_count'=> $input['reserved_count']?$input['reserved_count']: 0,
                'product_id'    => $product->id,
                'variant_id'    => $input['variant_id']?$input['variant_id'] : null,
                'variant_option_id' => $input['variant_option_id']?$input['variant_option_id']: null,
              //  'parent_product_option_id'  => $input['parent_product_option_id']? $input['parent_product_option_id']: null,               
                'created_at'    => \Carbon\Carbon::now(), # new \Datetime()
                'updated_at'    => \Carbon\Carbon::now()  # new \Datetime()
            ];
            DB::table('product_options')->insert($in_prod_opt);
        }

        ####### Product Variants ######
        if(isset($input['variant_id']) && $input['variant_id'] > 0){ 

            $in_prod_var = [               
                "product_id"    => $product->id,
                "variant_id"    => $input['variant_id']?$input['variant_id'] : null,
                "created_at"    => \Carbon\Carbon::now(), # new \Datetime()
                "updated_at"    => \Carbon\Carbon::now()  # new \Datetime()
            ];
            DB::table('product_variants')->insert($in_prod_var);
        }

        ####### Product Attributes ######
        if(isset($input['attribute_id']) && $input['attribute_id'] != ''){   
            $lastId = DB::table('product_attributes')->orderBy('id', 'desc')->first()->id;

            $in_prod_attr = [
                "id"            => (int) $lastId+1,
                "product_id"    => $product->id,
                "attribute_id"  => $input['attribute_id']?$input['attribute_id'] : null,
                "value"         => $input['attr_value']?$input['attr_value']: null,
                "created_at"    => \Carbon\Carbon::now(), # new \Datetime()
                "updated_at"    => \Carbon\Carbon::now()  # new \Datetime()
            ];
            DB::table('product_attributes')->insert($in_prod_attr);
        }
               
        return redirect()->route('products.index')
                        ->with('success','Products created successfully');
    }

    

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {   

        $product = DB::table('products as p')
                    //->leftJoin('product_options as po', 'po.product_id', '=', 'p.id')
                    ->leftJoin('images as im', 'p.default_image_id', '=', 'im.id')
                    ->select('p.*','im.url as image')   
                    ->where('p.id','=', $id)
                    ->first();

        $productoptions = DB::table('product_options as po')
                    ->leftJoin('products as p', 'po.product_id', '=', 'p.id')
                    ->leftJoin('variants as v', 'po.variant_id', '=', 'v.id')
                    ->leftJoin('variant_options as vo', 'po.variant_option_id', '=', 'vo.id')
                    ->select('po.*', 'v.name as variant', 'vo.value as variantoption')   
                    ->where('po.product_id','=', $id)
                    ->get();


        $productattributes = DB::table('product_attributes as pa')
                    ->leftJoin('products as p', 'pa.product_id', '=', 'p.id')
                    ->leftJoin('attributes as a', 'pa.attribute_id', '=', 'a.id')
                    ->select('pa.*', 'a.name as attrname')   
                    ->where('pa.product_id','=', $id)
                    ->get();

        $productvariants = DB::table('product_variants as pv')
                    ->leftJoin('products as p', 'pv.product_id', '=', 'p.id')
                    ->leftJoin('variants as v', 'pv.variant_id', '=', 'v.id')
                    ->select('pv.*', 'v.name as variant')   
                    ->where('pv.product_id','=', $id)
                    ->get();

        // Categories
        $categories = DB::table('categories as child')
            ->leftJoin('categories as parent', 'child.category_id', '=', 'parent.id')
            ->select('child.*', 'parent.name as parent')   
            ->where('child.category_id','<>', 0)        
            ->orderBy('child.id', 'DESC')->get();

        $brand = Brand::all()->pluck('name', 'id')->toArray();  

        $countries = DB::table('countries')->orderBy('name', 'ASC')
                        ->pluck('name', 'id')->toArray();

        $measurement = DB::table('measurement')->orderBy('name', 'ASC')
                        ->pluck('name', 'id')->toArray();

        //$products = Product::all();
        
        $variants = DB::table('variants')
                        ->orderBy('name', 'ASC')
                        ->pluck('name', 'id')->toArray();

        // variant options
        $variant_options =  DB::table('variant_options')
                            ->orderBy('id', 'desc')
                            ->pluck("value", "id")->toArray();

        // attributes

resources/views/__new_product/edit.blade.php
@extends('layouts.admin')


@section('content')
<!-- Content Header (Page header) -->
<section class="content-header">
  <div class="container-fluid">
    <div class="row mb-2">
      <div class="col-sm-6">
        <h1>Edit Product</h1>
      </div>
      <div class="col-sm-6">
        <ol class="breadcrumb float-sm-right">
          <li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
          <li class="breadcrumb-item"><a href="{{ route('products.index') }}">Products</a></li>
          <li class="breadcrumb-item active">Edit Product</li>
        </ol>
      </div>
    </div>
  </div><!-- /.container-fluid -->
</section>
<!-- Main content -->

<!-- Main content -->
<section class="content">
    <div class="container justify-content-center">
      <div class="row">
        <!-- left column -->
     
      <div class="col">
        <!-- general form elements -->        
        <div class="card">
          <div class="card-header p-2">
            <ul class="nav nav-pills">
              <li class="nav-item"><a class="nav-link active" href="#activity" data-toggle="tab">General</a></li>
              <li class="nav-item"><a class="nav-link" href="#timeline" data-toggle="tab">Inventory</a></li>
              <li class="nav-item"><a class="nav-link" href="#settings" data-toggle="tab">Attributes</a></li>
            </ul>
          </div><!-- /.card-header -->
           {!! Form::model($product, ['method' => 'PATCH', 'enctype' => 'multipart/form-data', 'route' => ['products.update', $product->id]]) !!}   
          <div class="card-body">
            @if (count($errors) > 0)
            <div class="alert alert-danger">
                <strong>Whoops!</strong> There were some problems with your input.<br><br>
                <ul>
                   @foreach ($errors->all() as $error)
                     <li>{{ $error }}</li>
                   @endforeach
                </ul>
            </div>
            @endif            
            <div class="tab-content">
              <div class="active tab-pane" id="activity">
                @include('product.partials.editstep1')
              </div>
              <div class="tab-pane" id="timeline">
                @include('product.partials.editstep2')
              </div>
              <div class="tab-pane" id="settings">
                @include('product.partials.editstep3')
              </div>
            </div>
          </div>
          <!-- card body -->
          <div class="card-footer">
            <button type="submit" class="btn btn-primary">Save</button>
            <a class="btn btn-secondary float-right" href="{{ route('products.index') }}"> Cancel</a>
          </div>
          <!-- card footer -->
          {!! Form::close() !!}
        </div>
        
        <!-- card-->
      </div>
      <!-- col -->
    </div>
    <!-- row -->
  </div>
</section>
<script type="text/javascript"> 
  $(function () {
    $.ajaxSetup({
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        }
    });
    // Variant and its options
    $('#variant_id').on ('change', function(e){
      let variant_id = $(this).val();
      let htm = '<option value="">-- Select --</option>';
      if(variant_id){
         $.ajax({
            url:"{{ route('variant.options') }}",
            method:"POST",
            data:{variant_id: variant_id}, 
            success:function(data){
             
              if(data){
                $.each(data, function(index, opt){
                  htm += '<option value="'+index+'">'+opt+'</option>';
                });                
              }
              $('#variant_option_id').html(htm);
            }
        });

      }else{
        $('#variant_option_id').html(htm);
      }
    });
    var attr = [];
    // Unit and its attributes
    $('#measurement').on ('change', function(e){
      let measurement_id = $(this).val();
      let htm = '<option value="">-- Select --</option>';
      if(measurement_id){
         $.ajax({
            url:"{{ route('measurement.attributes') }}",
            method:"POST",
            data:{measurement_id: measurement_id}, 
            success:function(data){
             
              if(data){
                attr = data;
                $.each(data, function(index, opt){
                  htm += '<option value="'+opt.id+'">'+opt.name+'</option>';
                });                
              }
              $('#attribute_id').html(htm);
              $('#attr_value').val('');
            }
        });

      }else{
        $('#attribute_id').html(htm);$('#attr_value').val('');

        if(!$('#attr_value').hasAttr('disabled')){
          $('#attr_value').attr( "disabled", true );
        }
      }
    });

    $('#attribute_id').on ('change', function(e){
      let attrid = $(this).val();
      if(!attrid){
        $('#attr_value').attr( "disabled", true );
      }else{
        $.each(attr, function(index, opt){
          if(opt.id == attrid){ console.log(opt.id, attrid);

            $('#attr_value').removeAttr( "disabled").val(opt.default_value);
          }
        });
      }
      
                  
    });

    // Summernote
    $('.summernote').summernote({
      height: 150,   //set editable area's height
      codemirror: { // codemirror options
        theme: 'monokai'
      }
    });

    $('#file-input').on('change', function(){ //on file input change
        if (window.File && window.FileReader && window.FileList && window.Blob) //check File API supported browser
        {             
            var data = $(this)[0].files; //this file data
            
            $.each(data, function(index, file){ //loop though each file
                if(/(\.|\/)(bmp|jpe?g|png)$/i.test(file.type)){ //check supported file type
                    var fRead = new FileReader(); //new filereader
                    fRead.onload = (function(file){ //trigger function on successful read
                        return function(e) {                           
                          let preview = $('<img/>').addClass('img-fluid img-thumbnail m-1 mht-100').attr('src', e.target.result); //create image element                           
                          $('#thumb-output').append(preview); //append image to output element
                        };
                    })(file);
                    fRead.readAsDataURL(file); //URL representing the file's data.
                    $('#file-error').html("");
                }else{                        
                    $('#file-error').html("Selected file extension not allowed");
                    return;
                }; 
            });
             
        }else{
            alert("Your browser doesn't support File API!"); //if File API is absent
        }
    }); 

    $('#file-input-def').on('change', function(){ //on file input change
        if (window.File && window.FileReader && window.FileList && window.Blob) //check File API supported browser
        {             
            var data = $(this)[0].files; //this file data
            
            $.each(data, function(index, file){ //loop though each file
                if(/(\.|\/)(bmp|jpe?g|png)$/i.test(file.type)){ //check supported file type
                    var fRead = new FileReader(); //new filereader
                    fRead.onload = (function(file){ //trigger function on successful read
                        return function(e) {                           
                          let preview = $('<img/>').addClass('img-fluid img-thumbnail m-1 mht-100').attr('src', e.target.result); //create image element                           
                          $('#thumb-output-def').html(preview); //append image to output element
                        };
                    })(file);
                    fRead.readAsDataURL(file); //URL representing the file's data.
                    $('#file-error-def').html("");
                }else{                        
                    $('#file-error-def').html("Selected file extension not allowed");
                    return;
                }; 
            });
             
        }else{
            alert("Your browser doesn't support File API!"); //if File API is absent
        }
    });   
});
</script>
@endsection

resources/views/__new_product/index.blade.php
@extends('layouts.admin')


@section('content')
<!-- Content Header (Page header) -->
<section class="content-header">
  <div class="container-fluid">
    <div class="row mb-2">
      <div class="col-sm-6">
        <h1>Products</h1>
      </div>
      <div class="col-sm-6">
        <ol class="breadcrumb float-sm-right">
          <li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
          <li class="breadcrumb-item active">Manage Product</li>
        </ol>
      </div>
    </div>
  </div><!-- /.container-fluid -->
</section>
<!-- Main content -->
<section class="content">
  <div class="container-fluid">
    <div class="row">
      <div class="col">
        <div class="card">
        <div class="card-header">
          <h3 class="card-title">Manage Products</h3>          
            
            <a class="btn bg-gradient-danger float-right delete-all" href="javascript:void(0);" title="Delete All">DELETE ALL</a>  
            <a class="btn bg-gradient-success float-right mr-3" href="{{ route('products.create') }}" title="Add New">CREATE NEW</i></a>    
        </div>
        <!-- /.card-header -->
        <div class="card-body">
          @if ($message = Session::get('success'))
            <div class="alert alert-success">
                <p>{{ $message }}</p>
            </div>
          @endif
          <table id="product-tbl" class="table table-bordered table-hover">
            <thead>
            <tr>
              <th><input type="checkbox" id="check_all" >
              </th>
              <th>Image</th>
              <th>Name</th>  
              <th>Price (AED)</th>
              <th>Category</th>
              <th>Brand</th>
              <th>Created At</th>
              <th>Action</th>                  
            </tr>
            </thead>
            <tbody> 
            @foreach ($products as $i => $prod)
              @php
                $time = strtotime($prod->created_at) + 60*60*4;
              @endphp               
            <tr id="tr_{{$prod->id}}">
              <td><input type="checkbox" class="checkbox" data-id="{{$prod->id}}"></td>
              <td>@if($prod->image)
                <img src="https://api.menu4u.ae/api/image/{{$prod->image}}" class="img-fluid img-thumbnail m-1" style="max-height: 50px;">
                @else
                No Image
                @endif

              </td>
              <td>{{ $prod->name }}</td>
              <td>{{ $prod->price }}</td>
              <td>{{ $prod->category }}</td>
              <td>{{ $prod->brand }}</td>              
              <td>{{ date("d-m-Y H:i:s", $time) }}</td>                    
              <td>
                <a class="btn btn-success" href="{{ route('products.edit',$prod->id) }}" title="Edit"><i class="fas fa-edit"></i></a>                
                {!! Form::open(['method' => 'DELETE','route' => ['products.destroy', $prod->id],'style'=>'display:inline']) !!}
                <button type="submit" class="ml-2 btn btn-danger" title="Delete"><i class="fas fa-trash"></i></button>
                {!! Form::close() !!}               
              </td>
            </tr>
             @endforeach  
            </tbody>
            <tfoot>
            <tr>
              <th>#</th>
              <th>Image</th>
              <th>Name</th>  
              <th>Price (AED)</th>
              <th>Category</th>
              <th>Brand</th>
              <th>Created At</th>
              <th>Action</th>                      
            </tr>                  
            </tr>
            </tfoot>
          </table>          
        </div>
        <!-- /.card-body -->
        </div>
        <!-- /.card -->
      </div>
      <!-- <div class="col">&nbsp;</div> -->
    </div>
  </div>
</section> 
<!-- /.content -->

<script type="text/javascript">
$(document).ready(function () {

  $('#check_all').on('click', function(e) {
   if($(this).is(':checked',true))  
   {
      $(".checkbox").prop('checked', true);  
   } else {  
      $(".checkbox").prop('checked',false);  
   }
  });

  $('.checkbox').on('click',function(){
    if($('.checkbox:checked').length == $('.checkbox').length){
        $('#check_all').prop('checked',true);
    }else{
        $('#check_all').prop('checked',false);
    }
  });

  $.ajaxSetup({
      headers: {
          'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
      }
  });

  $('.delete-all').on('click', function(e) {

      var idsArr = [];  

      $(".checkbox:checked").each(function() {  
          idsArr.push($(this).attr('data-id'));
      });  



      if(idsArr.length <=0)  
      {  

          alert("Please select atleast one record to delete.");  

      }  else {  

          if(confirm("Are you sure, you want to delete the selected products?")){ 
              var strIds = idsArr.join(","); 
              $.ajax({

                  url: "{{ route('products.multipledelete') }}",

                  type: 'DELETE',

         //         headers: {'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')},

                  data: 'ids='+strIds,

                  success: function (data) {
                      if (data.status == true) {
                          $(".checkbox:checked").each(function() {  
                              $(this).parents("tr").remove();

                          });

                          //alert(data['message']);
                          toastr.success(data.message); 

                      } else {

                          // alert('Whoops Something went wrong!!');
                          toastr.error(data.message); 

                      }
                  },
                  error: function (data) {
                    //  alert(data.responseText);
                    toastr.error(data.responseJSON.errors); 
                  }

              });

          }  

      }  

  });

    });

</script>
@endsection